#!/bin/perl
#
# Print the percentage of cloned tokens in a project
#
# Copyright (c) 2007, Diomidis Spinellis
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: cloneval.pl,v 1.2 2007/09/12 17:39:12 dds Exp $
#

open(IN, "ccfx.exe P $ARGV[0].ccfxd|") || die;
while (<IN>) {
	chop;
	if (/^source_files/ .. /^\}/) {
		($id, $name, $tok) = split;
		$file[$id][$tok - 1] = 0 if ($tok > 0);
		$nfile++;
	} elsif (/^clone_pairs/ .. /^\}/) {
		($id, $c1, $c2) = split;
		mapfile($c1);
		mapfile($c1);
	}
}

sub
mapfile
{
	my($clone) = @_;
	($fid, $start, $end) = ($clone =~ m/^(\d+)\.(\d+)\-(\d+)$/);
	for ($i = $start; $i <= $end; $i++) {
		$file[$id][$i] = 1;
	}
}

for ($fid = 0 ; $fid <= $#file; $fid++) {
	for ($tokid = 0; $tokid <= $#{$file[$fid]}; $tokid++) {
		$ntok++;
		$nclone += $file[$fid][$tokid];
	}
}

print "$ARGV[0] nfiles=$nfile ntok=$ntok nclone=$nclone ", $nclone / $ntok * 100, "\n";
